"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

var _spResource = require("sp-resource");

var _spResource2 = _interopRequireDefault(_spResource);

var _underscore = require("underscore");

var _underscore2 = _interopRequireDefault(_underscore);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Channel = function (_Resource) {
  _inherits(Channel, _Resource);

  function Channel() {
    _classCallCheck(this, Channel);

    return _possibleConstructorReturn(this, (Channel.__proto__ || Object.getPrototypeOf(Channel)).apply(this, arguments));
  }

  _createClass(Channel, [{
    key: "default",
    value: function _default(ctx) {
      return _get(Channel.prototype.__proto__ || Object.getPrototypeOf(Channel.prototype), "default", this).call(this).then(function (doc) {
        return _extends({}, doc, {
          userId: ctx.user.id,
          users: []
        });
      });
    }
  }, {
    key: "validate",
    value: function validate(ctx, doc) {
      return _get(Channel.prototype.__proto__ || Object.getPrototypeOf(Channel.prototype), "validate", this).call(this, ctx, doc).then(function (doc) {
        var userIds = doc.users.map(function (u) {
          return u.userId;
        });
        if (userIds.length !== _underscore2.default.uniq(userIds).length) {
          throw new _spResource2.default.APIError(422, "Each user may only be in a channel once.");
        }
        return doc;
      });
    }
  }, {
    key: "auth",
    value: function auth(ctx, doc) {
      return Promise.resolve();
    }
  }, {
    key: "authQuery",
    value: function authQuery(ctx, query) {
      return Promise.resolve({});
    }
  }]);

  return Channel;
}(_spResource2.default);

exports.default = Channel;


Channel.tableName = "channels";