"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

var _spResource = require("sp-resource");

var _spResource2 = _interopRequireDefault(_spResource);

var _spClient = require("sp-client");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var S3_HOST = _spClient.config.require("S3_HOST");
var S3_BUCKET = _spClient.config.require("S3_BUCKET");

var File = function (_Resource) {
  _inherits(File, _Resource);

  function File() {
    _classCallCheck(this, File);

    return _possibleConstructorReturn(this, (File.__proto__ || Object.getPrototypeOf(File)).apply(this, arguments));
  }

  _createClass(File, [{
    key: "default",
    value: function _default(ctx) {
      return _get(File.prototype.__proto__ || Object.getPrototypeOf(File.prototype), "default", this).call(this).then(function (doc) {
        return _extends({}, doc, {
          userId: ctx.user.id,
          host: S3_HOST,
          bucket: S3_BUCKET,
          state: "AWAITING_UPLOAD"
        });
      });
    }
  }, {
    key: "auth",
    value: function auth(ctx, doc) {
      if (ctx.isPrivileged()) {
        return Promise.resolve();
      }
      if (doc.userId !== ctx.user.id) {
        throw new _spResource2.default.APIError(403, "You may only access your own files");
      }
      return Promise.resolve();
    }
  }, {
    key: "authQuery",
    value: function authQuery(ctx, query) {
      if (ctx.isPrivileged()) {
        return Promise.resolve({});
      }
      return Promise.resolve({ userId: ctx.user.id });
    }
  }, {
    key: "create",
    value: function create(ctx, newDoc) {
      newDoc.uploadKey = (0, _spClient.randomId)();
      return _get(File.prototype.__proto__ || Object.getPrototypeOf(File.prototype), "create", this).call(this, ctx, newDoc);
    }
  }]);

  return File;
}(_spResource2.default);

exports.default = File;