"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

var _spResource = require("sp-resource");

var _spResource2 = _interopRequireDefault(_spResource);

var _spClient = require("sp-client");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Stream = function (_Resource) {
  _inherits(Stream, _Resource);

  function Stream() {
    _classCallCheck(this, Stream);

    return _possibleConstructorReturn(this, (Stream.__proto__ || Object.getPrototypeOf(Stream)).apply(this, arguments));
  }

  _createClass(Stream, [{
    key: "default",
    value: function _default(ctx) {
      return _get(Stream.prototype.__proto__ || Object.getPrototypeOf(Stream.prototype), "default", this).call(this).then(function (doc) {
        return _extends({}, doc);
      });
    }
  }, {
    key: "create",
    value: function create(ctx, newDoc) {
      var _this2 = this;

      var newStream = void 0;
      return _get(Stream.prototype.__proto__ || Object.getPrototypeOf(Stream.prototype), "create", this).call(this, ctx, newDoc).then(function (_newStream) {
        newStream = _newStream;
        return _this2.find(ctx, { source: { id: newStream.source.id } });
      }).then(function (otherStreams) {
        // Don't delete yourself, you dingus
        otherStreams = otherStreams.filter(function (stream) {
          return stream.id !== newStream.id;
        });
        return Promise.all(otherStreams.map(function (stream) {
          return _this2.delete(ctx, stream.id);
        }));
      }).then(function () {
        return newStream;
      });
    }
  }, {
    key: "authStreamSource",
    value: function authStreamSource(ctx, doc) {
      var sourceResource = Object.keys(ctx).map(function (key) {
        return ctx[key];
      }).find(function (resource) {
        if (!resource.resource) {
          return;
        }
      });
    }

    // For now, end users don't interact with these at all

  }, {
    key: "auth",
    value: function auth(ctx, doc) {
      if (ctx.isPrivileged()) {
        return Promise.resolve();
      }
      return this.authStreamSource(ctx, doc);
    }
  }, {
    key: "authUpdate",
    value: function authUpdate(ctx, doc, newDoc) {
      if (!ctx.isPrivileged()) {
        throw new _spResource2.default.APIError(403, "Streams are read-only, alter the source instead");
      }
      return Promise.resolve();
    }
  }, {
    key: "authDelete",
    value: function authDelete(ctx, doc, newDoc) {
      if (!ctx.isPrivileged()) {
        throw new _spResource2.default.APIError(403, "Streams are read-only, alter the source instead");
      }
      return Promise.resolve();
    }
  }, {
    key: "authQuery",
    value: function authQuery(ctx, query) {
      if (ctx.isPrivileged()) {
        return Promise.resolve({});
      }
      if (!query.source || !query.source.id) {
        return Promise.resolve({ id: null });
      }
      // Right now if you know the id of a stream's source, you can query that
      // stream. This may need to change at some point.
      return Promise.resolve({ source: { id: query.source.id } });
    }
  }]);

  return Stream;
}(_spResource2.default);

exports.default = Stream;